package com.chinaitop.depot.intelligent.weather.model;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class TWeatherhsitoryExample {
    /**
     * t_weatherhsitory
     */
    protected String orderByClause;

    /**
     * t_weatherhsitory
     */
    protected boolean distinct;

    /**
     * t_weatherhsitory
     */
    protected List<Criteria> oredCriteria;

    public TWeatherhsitoryExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    /**
     * t_weatherhsitory 2019-06-21
     */
    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNull() {
            addCriterion("org_id is null");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNotNull() {
            addCriterion("org_id is not null");
            return (Criteria) this;
        }

        public Criteria andOrgIdEqualTo(String value) {
            addCriterion("org_id =", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotEqualTo(String value) {
            addCriterion("org_id <>", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThan(String value) {
            addCriterion("org_id >", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThanOrEqualTo(String value) {
            addCriterion("org_id >=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThan(String value) {
            addCriterion("org_id <", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThanOrEqualTo(String value) {
            addCriterion("org_id <=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLike(String value) {
            addCriterion("org_id like", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotLike(String value) {
            addCriterion("org_id not like", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdIn(List<String> values) {
            addCriterion("org_id in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotIn(List<String> values) {
            addCriterion("org_id not in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdBetween(String value1, String value2) {
            addCriterion("org_id between", value1, value2, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotBetween(String value1, String value2) {
            addCriterion("org_id not between", value1, value2, "orgId");
            return (Criteria) this;
        }

        public Criteria andSitecodeIsNull() {
            addCriterion("sitecode is null");
            return (Criteria) this;
        }

        public Criteria andSitecodeIsNotNull() {
            addCriterion("sitecode is not null");
            return (Criteria) this;
        }

        public Criteria andSitecodeEqualTo(String value) {
            addCriterion("sitecode =", value, "sitecode");
            return (Criteria) this;
        }

        public Criteria andSitecodeNotEqualTo(String value) {
            addCriterion("sitecode <>", value, "sitecode");
            return (Criteria) this;
        }

        public Criteria andSitecodeGreaterThan(String value) {
            addCriterion("sitecode >", value, "sitecode");
            return (Criteria) this;
        }

        public Criteria andSitecodeGreaterThanOrEqualTo(String value) {
            addCriterion("sitecode >=", value, "sitecode");
            return (Criteria) this;
        }

        public Criteria andSitecodeLessThan(String value) {
            addCriterion("sitecode <", value, "sitecode");
            return (Criteria) this;
        }

        public Criteria andSitecodeLessThanOrEqualTo(String value) {
            addCriterion("sitecode <=", value, "sitecode");
            return (Criteria) this;
        }

        public Criteria andSitecodeLike(String value) {
            addCriterion("sitecode like", value, "sitecode");
            return (Criteria) this;
        }

        public Criteria andSitecodeNotLike(String value) {
            addCriterion("sitecode not like", value, "sitecode");
            return (Criteria) this;
        }

        public Criteria andSitecodeIn(List<String> values) {
            addCriterion("sitecode in", values, "sitecode");
            return (Criteria) this;
        }

        public Criteria andSitecodeNotIn(List<String> values) {
            addCriterion("sitecode not in", values, "sitecode");
            return (Criteria) this;
        }

        public Criteria andSitecodeBetween(String value1, String value2) {
            addCriterion("sitecode between", value1, value2, "sitecode");
            return (Criteria) this;
        }

        public Criteria andSitecodeNotBetween(String value1, String value2) {
            addCriterion("sitecode not between", value1, value2, "sitecode");
            return (Criteria) this;
        }

        public Criteria andVqxzcodeIsNull() {
            addCriterion("vqxzcode is null");
            return (Criteria) this;
        }

        public Criteria andVqxzcodeIsNotNull() {
            addCriterion("vqxzcode is not null");
            return (Criteria) this;
        }

        public Criteria andVqxzcodeEqualTo(String value) {
            addCriterion("vqxzcode =", value, "vqxzcode");
            return (Criteria) this;
        }

        public Criteria andVqxzcodeNotEqualTo(String value) {
            addCriterion("vqxzcode <>", value, "vqxzcode");
            return (Criteria) this;
        }

        public Criteria andVqxzcodeGreaterThan(String value) {
            addCriterion("vqxzcode >", value, "vqxzcode");
            return (Criteria) this;
        }

        public Criteria andVqxzcodeGreaterThanOrEqualTo(String value) {
            addCriterion("vqxzcode >=", value, "vqxzcode");
            return (Criteria) this;
        }

        public Criteria andVqxzcodeLessThan(String value) {
            addCriterion("vqxzcode <", value, "vqxzcode");
            return (Criteria) this;
        }

        public Criteria andVqxzcodeLessThanOrEqualTo(String value) {
            addCriterion("vqxzcode <=", value, "vqxzcode");
            return (Criteria) this;
        }

        public Criteria andVqxzcodeLike(String value) {
            addCriterion("vqxzcode like", value, "vqxzcode");
            return (Criteria) this;
        }

        public Criteria andVqxzcodeNotLike(String value) {
            addCriterion("vqxzcode not like", value, "vqxzcode");
            return (Criteria) this;
        }

        public Criteria andVqxzcodeIn(List<String> values) {
            addCriterion("vqxzcode in", values, "vqxzcode");
            return (Criteria) this;
        }

        public Criteria andVqxzcodeNotIn(List<String> values) {
            addCriterion("vqxzcode not in", values, "vqxzcode");
            return (Criteria) this;
        }

        public Criteria andVqxzcodeBetween(String value1, String value2) {
            addCriterion("vqxzcode between", value1, value2, "vqxzcode");
            return (Criteria) this;
        }

        public Criteria andVqxzcodeNotBetween(String value1, String value2) {
            addCriterion("vqxzcode not between", value1, value2, "vqxzcode");
            return (Criteria) this;
        }

        public Criteria andVqxznameIsNull() {
            addCriterion("vqxzname is null");
            return (Criteria) this;
        }

        public Criteria andVqxznameIsNotNull() {
            addCriterion("vqxzname is not null");
            return (Criteria) this;
        }

        public Criteria andVqxznameEqualTo(String value) {
            addCriterion("vqxzname =", value, "vqxzname");
            return (Criteria) this;
        }

        public Criteria andVqxznameNotEqualTo(String value) {
            addCriterion("vqxzname <>", value, "vqxzname");
            return (Criteria) this;
        }

        public Criteria andVqxznameGreaterThan(String value) {
            addCriterion("vqxzname >", value, "vqxzname");
            return (Criteria) this;
        }

        public Criteria andVqxznameGreaterThanOrEqualTo(String value) {
            addCriterion("vqxzname >=", value, "vqxzname");
            return (Criteria) this;
        }

        public Criteria andVqxznameLessThan(String value) {
            addCriterion("vqxzname <", value, "vqxzname");
            return (Criteria) this;
        }

        public Criteria andVqxznameLessThanOrEqualTo(String value) {
            addCriterion("vqxzname <=", value, "vqxzname");
            return (Criteria) this;
        }

        public Criteria andVqxznameLike(String value) {
            addCriterion("vqxzname like", value, "vqxzname");
            return (Criteria) this;
        }

        public Criteria andVqxznameNotLike(String value) {
            addCriterion("vqxzname not like", value, "vqxzname");
            return (Criteria) this;
        }

        public Criteria andVqxznameIn(List<String> values) {
            addCriterion("vqxzname in", values, "vqxzname");
            return (Criteria) this;
        }

        public Criteria andVqxznameNotIn(List<String> values) {
            addCriterion("vqxzname not in", values, "vqxzname");
            return (Criteria) this;
        }

        public Criteria andVqxznameBetween(String value1, String value2) {
            addCriterion("vqxzname between", value1, value2, "vqxzname");
            return (Criteria) this;
        }

        public Criteria andVqxznameNotBetween(String value1, String value2) {
            addCriterion("vqxzname not between", value1, value2, "vqxzname");
            return (Criteria) this;
        }

        public Criteria andFtempIsNull() {
            addCriterion("ftemp is null");
            return (Criteria) this;
        }

        public Criteria andFtempIsNotNull() {
            addCriterion("ftemp is not null");
            return (Criteria) this;
        }

        public Criteria andFtempEqualTo(BigDecimal value) {
            addCriterion("ftemp =", value, "ftemp");
            return (Criteria) this;
        }

        public Criteria andFtempNotEqualTo(BigDecimal value) {
            addCriterion("ftemp <>", value, "ftemp");
            return (Criteria) this;
        }

        public Criteria andFtempGreaterThan(BigDecimal value) {
            addCriterion("ftemp >", value, "ftemp");
            return (Criteria) this;
        }

        public Criteria andFtempGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ftemp >=", value, "ftemp");
            return (Criteria) this;
        }

        public Criteria andFtempLessThan(BigDecimal value) {
            addCriterion("ftemp <", value, "ftemp");
            return (Criteria) this;
        }

        public Criteria andFtempLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ftemp <=", value, "ftemp");
            return (Criteria) this;
        }

        public Criteria andFtempIn(List<BigDecimal> values) {
            addCriterion("ftemp in", values, "ftemp");
            return (Criteria) this;
        }

        public Criteria andFtempNotIn(List<BigDecimal> values) {
            addCriterion("ftemp not in", values, "ftemp");
            return (Criteria) this;
        }

        public Criteria andFtempBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ftemp between", value1, value2, "ftemp");
            return (Criteria) this;
        }

        public Criteria andFtempNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ftemp not between", value1, value2, "ftemp");
            return (Criteria) this;
        }

        public Criteria andFhumiIsNull() {
            addCriterion("fhumi is null");
            return (Criteria) this;
        }

        public Criteria andFhumiIsNotNull() {
            addCriterion("fhumi is not null");
            return (Criteria) this;
        }

        public Criteria andFhumiEqualTo(BigDecimal value) {
            addCriterion("fhumi =", value, "fhumi");
            return (Criteria) this;
        }

        public Criteria andFhumiNotEqualTo(BigDecimal value) {
            addCriterion("fhumi <>", value, "fhumi");
            return (Criteria) this;
        }

        public Criteria andFhumiGreaterThan(BigDecimal value) {
            addCriterion("fhumi >", value, "fhumi");
            return (Criteria) this;
        }

        public Criteria andFhumiGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("fhumi >=", value, "fhumi");
            return (Criteria) this;
        }

        public Criteria andFhumiLessThan(BigDecimal value) {
            addCriterion("fhumi <", value, "fhumi");
            return (Criteria) this;
        }

        public Criteria andFhumiLessThanOrEqualTo(BigDecimal value) {
            addCriterion("fhumi <=", value, "fhumi");
            return (Criteria) this;
        }

        public Criteria andFhumiIn(List<BigDecimal> values) {
            addCriterion("fhumi in", values, "fhumi");
            return (Criteria) this;
        }

        public Criteria andFhumiNotIn(List<BigDecimal> values) {
            addCriterion("fhumi not in", values, "fhumi");
            return (Criteria) this;
        }

        public Criteria andFhumiBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("fhumi between", value1, value2, "fhumi");
            return (Criteria) this;
        }

        public Criteria andFhumiNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("fhumi not between", value1, value2, "fhumi");
            return (Criteria) this;
        }

        public Criteria andFwindsIsNull() {
            addCriterion("fwinds is null");
            return (Criteria) this;
        }

        public Criteria andFwindsIsNotNull() {
            addCriterion("fwinds is not null");
            return (Criteria) this;
        }

        public Criteria andFwindsEqualTo(BigDecimal value) {
            addCriterion("fwinds =", value, "fwinds");
            return (Criteria) this;
        }

        public Criteria andFwindsNotEqualTo(BigDecimal value) {
            addCriterion("fwinds <>", value, "fwinds");
            return (Criteria) this;
        }

        public Criteria andFwindsGreaterThan(BigDecimal value) {
            addCriterion("fwinds >", value, "fwinds");
            return (Criteria) this;
        }

        public Criteria andFwindsGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("fwinds >=", value, "fwinds");
            return (Criteria) this;
        }

        public Criteria andFwindsLessThan(BigDecimal value) {
            addCriterion("fwinds <", value, "fwinds");
            return (Criteria) this;
        }

        public Criteria andFwindsLessThanOrEqualTo(BigDecimal value) {
            addCriterion("fwinds <=", value, "fwinds");
            return (Criteria) this;
        }

        public Criteria andFwindsIn(List<BigDecimal> values) {
            addCriterion("fwinds in", values, "fwinds");
            return (Criteria) this;
        }

        public Criteria andFwindsNotIn(List<BigDecimal> values) {
            addCriterion("fwinds not in", values, "fwinds");
            return (Criteria) this;
        }

        public Criteria andFwindsBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("fwinds between", value1, value2, "fwinds");
            return (Criteria) this;
        }

        public Criteria andFwindsNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("fwinds not between", value1, value2, "fwinds");
            return (Criteria) this;
        }

        public Criteria andFwinddIsNull() {
            addCriterion("fwindd is null");
            return (Criteria) this;
        }

        public Criteria andFwinddIsNotNull() {
            addCriterion("fwindd is not null");
            return (Criteria) this;
        }

        public Criteria andFwinddEqualTo(BigDecimal value) {
            addCriterion("fwindd =", value, "fwindd");
            return (Criteria) this;
        }

        public Criteria andFwinddNotEqualTo(BigDecimal value) {
            addCriterion("fwindd <>", value, "fwindd");
            return (Criteria) this;
        }

        public Criteria andFwinddGreaterThan(BigDecimal value) {
            addCriterion("fwindd >", value, "fwindd");
            return (Criteria) this;
        }

        public Criteria andFwinddGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("fwindd >=", value, "fwindd");
            return (Criteria) this;
        }

        public Criteria andFwinddLessThan(BigDecimal value) {
            addCriterion("fwindd <", value, "fwindd");
            return (Criteria) this;
        }

        public Criteria andFwinddLessThanOrEqualTo(BigDecimal value) {
            addCriterion("fwindd <=", value, "fwindd");
            return (Criteria) this;
        }

        public Criteria andFwinddIn(List<BigDecimal> values) {
            addCriterion("fwindd in", values, "fwindd");
            return (Criteria) this;
        }

        public Criteria andFwinddNotIn(List<BigDecimal> values) {
            addCriterion("fwindd not in", values, "fwindd");
            return (Criteria) this;
        }

        public Criteria andFwinddBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("fwindd between", value1, value2, "fwindd");
            return (Criteria) this;
        }

        public Criteria andFwinddNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("fwindd not between", value1, value2, "fwindd");
            return (Criteria) this;
        }

        public Criteria andFpressureIsNull() {
            addCriterion("fpressure is null");
            return (Criteria) this;
        }

        public Criteria andFpressureIsNotNull() {
            addCriterion("fpressure is not null");
            return (Criteria) this;
        }

        public Criteria andFpressureEqualTo(BigDecimal value) {
            addCriterion("fpressure =", value, "fpressure");
            return (Criteria) this;
        }

        public Criteria andFpressureNotEqualTo(BigDecimal value) {
            addCriterion("fpressure <>", value, "fpressure");
            return (Criteria) this;
        }

        public Criteria andFpressureGreaterThan(BigDecimal value) {
            addCriterion("fpressure >", value, "fpressure");
            return (Criteria) this;
        }

        public Criteria andFpressureGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("fpressure >=", value, "fpressure");
            return (Criteria) this;
        }

        public Criteria andFpressureLessThan(BigDecimal value) {
            addCriterion("fpressure <", value, "fpressure");
            return (Criteria) this;
        }

        public Criteria andFpressureLessThanOrEqualTo(BigDecimal value) {
            addCriterion("fpressure <=", value, "fpressure");
            return (Criteria) this;
        }

        public Criteria andFpressureIn(List<BigDecimal> values) {
            addCriterion("fpressure in", values, "fpressure");
            return (Criteria) this;
        }

        public Criteria andFpressureNotIn(List<BigDecimal> values) {
            addCriterion("fpressure not in", values, "fpressure");
            return (Criteria) this;
        }

        public Criteria andFpressureBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("fpressure between", value1, value2, "fpressure");
            return (Criteria) this;
        }

        public Criteria andFpressureNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("fpressure not between", value1, value2, "fpressure");
            return (Criteria) this;
        }

        public Criteria andFrainIsNull() {
            addCriterion("frain is null");
            return (Criteria) this;
        }

        public Criteria andFrainIsNotNull() {
            addCriterion("frain is not null");
            return (Criteria) this;
        }

        public Criteria andFrainEqualTo(BigDecimal value) {
            addCriterion("frain =", value, "frain");
            return (Criteria) this;
        }

        public Criteria andFrainNotEqualTo(BigDecimal value) {
            addCriterion("frain <>", value, "frain");
            return (Criteria) this;
        }

        public Criteria andFrainGreaterThan(BigDecimal value) {
            addCriterion("frain >", value, "frain");
            return (Criteria) this;
        }

        public Criteria andFrainGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("frain >=", value, "frain");
            return (Criteria) this;
        }

        public Criteria andFrainLessThan(BigDecimal value) {
            addCriterion("frain <", value, "frain");
            return (Criteria) this;
        }

        public Criteria andFrainLessThanOrEqualTo(BigDecimal value) {
            addCriterion("frain <=", value, "frain");
            return (Criteria) this;
        }

        public Criteria andFrainIn(List<BigDecimal> values) {
            addCriterion("frain in", values, "frain");
            return (Criteria) this;
        }

        public Criteria andFrainNotIn(List<BigDecimal> values) {
            addCriterion("frain not in", values, "frain");
            return (Criteria) this;
        }

        public Criteria andFrainBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("frain between", value1, value2, "frain");
            return (Criteria) this;
        }

        public Criteria andFrainNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("frain not between", value1, value2, "frain");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNull() {
            addCriterion("remark is null");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNotNull() {
            addCriterion("remark is not null");
            return (Criteria) this;
        }

        public Criteria andRemarkEqualTo(String value) {
            addCriterion("remark =", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotEqualTo(String value) {
            addCriterion("remark <>", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThan(String value) {
            addCriterion("remark >", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThanOrEqualTo(String value) {
            addCriterion("remark >=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThan(String value) {
            addCriterion("remark <", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThanOrEqualTo(String value) {
            addCriterion("remark <=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLike(String value) {
            addCriterion("remark like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotLike(String value) {
            addCriterion("remark not like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkIn(List<String> values) {
            addCriterion("remark in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotIn(List<String> values) {
            addCriterion("remark not in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkBetween(String value1, String value2) {
            addCriterion("remark between", value1, value2, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotBetween(String value1, String value2) {
            addCriterion("remark not between", value1, value2, "remark");
            return (Criteria) this;
        }

        public Criteria andDataSourceIsNull() {
            addCriterion("data_source is null");
            return (Criteria) this;
        }

        public Criteria andDataSourceIsNotNull() {
            addCriterion("data_source is not null");
            return (Criteria) this;
        }

        public Criteria andDataSourceEqualTo(String value) {
            addCriterion("data_source =", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotEqualTo(String value) {
            addCriterion("data_source <>", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceGreaterThan(String value) {
            addCriterion("data_source >", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceGreaterThanOrEqualTo(String value) {
            addCriterion("data_source >=", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceLessThan(String value) {
            addCriterion("data_source <", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceLessThanOrEqualTo(String value) {
            addCriterion("data_source <=", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceLike(String value) {
            addCriterion("data_source like", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotLike(String value) {
            addCriterion("data_source not like", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceIn(List<String> values) {
            addCriterion("data_source in", values, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotIn(List<String> values) {
            addCriterion("data_source not in", values, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceBetween(String value1, String value2) {
            addCriterion("data_source between", value1, value2, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotBetween(String value1, String value2) {
            addCriterion("data_source not between", value1, value2, "dataSource");
            return (Criteria) this;
        }
    }

    /**
     * t_weatherhsitory
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    /**
     * t_weatherhsitory 2019-06-21
     */
    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}